#!/usr/bin/python2

from gtk import *
import GtkExtra
import random
import math
import sys

import pil2drawable

import Image
import os.path, string
import gtkpildisplay
import utility
import dircache, os, time

from error import Error

class Viewer(GtkVBox):
        def load_image(self):
                try:
                    self.canv.current_image = Image.open(self.fname)
                except:
                    Error("Could not load image. Perhaps it is corrupted?").show()
                    self.canv.current_image = None
        
        def timeout(self):
                fs = os.path.getsize(self.fname)
                if(self.size <= fs):
                        self.load_image()
                        self.canv.queue_draw()
                        return 0
                
                if 1: #if self.previoussize > fs:
                        self.previoussize = fs
                        print "downloaded %d of %d" % (fs, self.size)
                return 1

        
        def delete_event(self, win, event=None):
                win.hide()
                # don't destroy window -- just leave it hidden
                return TRUE
        
        def process_transpose(self, action, widget):
                canv = self.canv
                ci = canv.current_image
                canv.current_image = ci.transpose({1:Image.ROTATE_90,
                                                                                     2:Image.ROTATE_180,
                                                                                     3:Image.ROTATE_270}[action])
                canv.queue_draw()
                pass

        def init_menu(self):
                ag = GtkAccelGroup()
                itemf = GtkItemFactory(GtkMenuBar, "<main>", ag)
                itemf.create_items([
                        ('/_Task',               None,          None,     0, '<Branch>'),
                        ('/_Task/Rotate 90',     ']',           self.process_transpose, 1, ''),
                        ('/_Task/Rotate 180',     '\\',          self.process_transpose, 2, ''),
                        ('/_Task/Rotate 270',     '[',          self.process_transpose, 3, ''),
                        ])
                return itemf.get_widget('<main>')
                        
        def create_browser_window(self):
                GtkVBox.__init__(self, FALSE, 0)

                self.canv = gtkpildisplay.GtkPILDisplay()
                self.canv.show()

                self.menubar = self.init_menu()
                self.pack_start(self.menubar, expand=FALSE)
                self.menubar.show()
                
                self.pack_start(self.canv)

                self.previoussize = 0
                if self.size <= os.path.getsize(self.fname):
                        #self.canv.current_image = Image.open(self.fname)
                        self.load_image()
                else:
                        self.canv.current_image = None
                        #print "the file is current still downloading..."

                        #Multiple calls to timeout_add crash windows gtk
                        #timeout_add(300, self.timeout)
                        utility.schedule_mainthread(300.0, self.timeout)
                
        def __init__(self, fname, size):
                self.fname = fname
                self.size = size
                self.create_browser_window()
        
class imageviewer(GtkWindow):
        def __init__(self, f, s, keep_file_checkbox=1):
                GtkWindow.__init__(self)
                title = os.path.basename(f)
                
                self.set_name(title)
                self.set_title(title)
                
                self.set_default_size(400, 400)
                browser = Viewer(f, s)
                self.add(browser)
                
                if keep_file_checkbox:
                    self.keep_file_button = GtkCheckButton("Keep file after playing")
                    browser.pack_start(self.keep_file_button, expand=FALSE)
                    self.keep_file_button.show()
                
                self.show_all()

def main(fname):
        win = imageviewer(fname, 0)
        win.connect("destroy", mainquit)
        mainloop()

if __name__ == '__main__': main(sys.argv[1])


# vim: set expandtab :
