#!/usr/bin/python2

from gtk import *
import GtkExtra
import random
import math
import sys

import os.path,sys,re,string
import dircache,os,time

from error import Error
import utility

class textviewer(GtkWindow):
        def timeout(self):
                if not self.running:
                    return 0

                try:
                    fs = os.path.getsize(self.fname)
                except OSError:
                    return 0

                if fs == 0: return 1
                if not self.file:
                        self.file = open(self.fname, "r")
                self.text.insert_defaults(self.file.read())
                if self.size > fs:
                        print "downloaded %d of %d" % (fs, self.size)
                        return 1
                
                print "finished download"
                
                return 0
        
        def delete_event(self, win, event=None):
                win.hide()
                # don't destroy window -- just leave it hidden
                
                self.running = 0
                
                return TRUE
        
        def __init__(self, fname, size, keep_file_checkbox=1):
                self.running = 1

                GtkWindow.__init__(self)
                title = os.path.basename(fname)
                self.fname = fname
                self.size = size
                self.set_name(title)
                self.set_title(title)
                self.set_default_size(500,500)

                self.vbox = GtkVBox(FALSE, 0)
                table = GtkTable(2, 2)
                table.set_row_spacing(0, 2)
                table.set_col_spacing(0, 2)
                self.vbox.pack_start(table)
                table.show()
                
                text = GtkText()
                text.set_editable(FALSE)
                table.attach(text, 0,1, 0,1)
                
                hscrollbar = GtkHScrollbar(text.get_hadjustment())
                table.attach(hscrollbar, 0,1, 1,2, yoptions=FILL)
                vscrollbar = GtkVScrollbar(text.get_vadjustment())
                table.attach(vscrollbar, 1,2, 0,1, xoptions=FILL)
                
                self.text = text
                
                self.file = None
                if self.size <= os.path.getsize(self.fname):
                        self.file = open(self.fname, "r")
                        self.text.insert_defaults(self.file.read())
                else:
                        #Multiple calls to timeout_add crash windows gtk
                        utility.schedule_mainthread(300.0, self.timeout)
                        
                self.add(self.vbox)

                if keep_file_checkbox:
                    self.keep_file_button = GtkCheckButton("Keep file after playing")
                    self.vbox.pack_start(self.keep_file_button, expand=FALSE)
                    self.keep_file_button.show()
                
                self.show_all()

def main(fname):
        win = textviewer(fname, 0)
        win.connect("destroy", mainquit)
        mainloop()

if __name__ == '__main__': main(sys.argv[1])


# vim: set expandtab :
