#! /usr/bin/env python

import string, sys,os

if int(string.split(sys.version,'.')[0]) <= 1:
  print "Circle requires Python version 2 or higher.\n"
  print "See the README for details."
  sys.exit(1)

try:
  from distutils.core import setup, Extension
  from distutils.command.build_ext import build_ext
  from distutils.command.install_data import install_data
  from distutils.errors import CCompilerError
except:
  print "\nCould not load the distutils modules. Have you installed them?\n"
  print "(on Debian systems you need to install the python2.X-dev package)\n"
  sys.exit(1)

import circlelib

include_dirs = [ ]
library_dirs = [ ]
libraries    = [ ]
try:
  file = os.popen("gtk-config --cflags --libs ; gdk-pixbuf-config --cflags --libs")
  for item in string.split(file.read()):
    if item[:2] == '-I':
      include_dirs.append(item[2:])
    if item[:2] == '-l':
      libraries.append(item[2:])
    if item[:2] == '-L':
      library_dirs.append(item[2:])
  file.close()
except:
  pass

class fallible_build_ext(build_ext):
  def run(self):
    try:
      build_ext.run(self)
    except CCompilerError:
      print """
Not installing pil2drawable.

Some images may not be displayed.
"""

class modified_install_data(install_data):
  def finalize_options(self):
    self.set_undefined_options('install',('install_lib','install_dir'))
    install_data.finalize_options(self)
	
setup(name = 'Circle',
      version = circlelib.__version__,
      description = 'Decentralized file sharing application',
      author = 'Paul Harrison',
      author_email = 'pfh@csse.monash.edu.au',
      url = 'http://yoyo.cc.monash.edu.au/~pfh/circle/',
      licence = 'GPL',
      long_description =
"""
A decentralized file sharing application in the style of Gnutella,
based around the idea of a decentralized hash.""",
      platforms = ['Linux'],

      cmdclass = { 'build_ext': fallible_build_ext,
                   'install_data': modified_install_data },

      packages = ['circlelib','circlelib.crypto'],
      scripts = ['circle','circled','circleget'],
      data_files = [
        ('circlelib',['circlelib/neko.xpm',
		      'circlelib/diagram-bg.xpm',
		      'circlelib/about.html',
		      'circlelib/chat_commands.html',
		      'circlelib/daemon_howto.html',
		      'circlelib/technical_faq.html',
		      'circlelib/getting_started.html',
		      'circlelib/magic.circle',
		      'circlelib/magic.linux']),
        ('/usr/share/pixmaps',['circle-icon.png']),
	('/usr/share/gnome/apps/Internet',['circle.desktop']),
	('/usr/lib/apt/methods',['cftp','chttp'])
      ],

      ext_modules = [
        Extension("pil2drawable",["circlelib/pil2drawable.cc"],
                  include_dirs = include_dirs,
		  library_dirs = library_dirs,
                  libraries = libraries
                 )
      ])



